/* How to find out the remote host's OS Type (Sun, Linux etc). */
/* Made by Shok.           --==+*~(Shok)~*+==--	 	       */
 
#include <sys/types.h>
#include <sys/socket.h>

#include <netinet/in.h>

#include <stdio.h>
#include <stdlib.h>

#include <netdb.h>
#include <unistd.h>

#define	NICHOST	"whois.internic.net"

main(argc, argv)
	int argc;
	char *argv[];
{
	int s;
	register FILE *sfi, *sfo;
	register int c;
	char *host = NICHOST;
	struct sockaddr_in sin;
	struct hostent *hp;
	struct servent *sp;
	char hnamebuf[32];
        char buf[5000];
	int addrtype;
        FILE *fd;

	system("touch /var/tmp/ostype");
        fd = fopen("/var/tmp/ostype", "w+");

	argc--, argv++;
	if (argc > 2 && strcmp(*argv, "-h") == 0) {
		argv++, argc--;
		host = *argv++;
		argc--;
	}

	printf("Checking via whois (must be a nameserver):");

	sin.sin_addr.s_addr = inet_addr(host);
	if (sin.sin_addr.s_addr != -1 && sin.sin_addr.s_addr != 0) {
		addrtype = AF_INET;
	} else {
		hp = gethostbyname(host);
		if (hp == NULL) {
			fprintf(stderr, "%s: host unknown\n", host);
			exit(1);
		}
		addrtype = hp->h_addrtype;
		host = hp->h_name;
		bcopy(hp->h_addr, &sin.sin_addr, hp->h_length);
	}

	s = socket(addrtype, SOCK_STREAM, 0);
	if (s < 0) {
		perror("socket");
		exit(2);
	}
	sin.sin_family = addrtype;
	sp = getservbyname("whois", "tcp");
	if (sp == NULL) {
		sin.sin_port = htons(IPPORT_WHOIS);
	}
	else sin.sin_port = sp->s_port;
	if (connect(s, (struct sockaddr *) &sin, sizeof (sin)) < 0) {
		perror("connect");
		exit(5);
	}
	sfi = fdopen(s, "r");
	sfo = fdopen(s, "w");

	if (sfi == NULL || sfo == NULL) {
		perror("fdopen");
		close(s);
		exit(1);
	}
	fprintf(sfo, "%s\r\n", *argv);
	fflush(sfo);

        while(1) {
        	fgets(buf, 4999, sfi);
                
                if(((char *)strstr(buf, "System")) == NULL) bzero(buf, 4999); 
                else break;
        }

       	fprintf(fd, "%s", buf);

        fclose(fd);
	exit(0);

}

