#include <unistd.h>
#include <stdio.h>

#define ERROR -1 

void main(int argc, char **argv) 
{
  char buf[15];
  FILE *fd;

  if ((argc == 3) || (argc == 2)) {
	printf("Checking via telnet: ");

	setenv("HOST", argv[1], 1);
	if (argc == 3) setenv("PORT", argv[2], 1);

	if (fork() == 0) {
		if (argc == 3) system("telnet $HOST $PORT &>/var/tmp/tel");
		else system("telnet $HOST &>/var/tmp/tel");
		exit(0);
	}
	
	sleep(3);
	system("ps | grep -v \"PID\" | grep \"telnet\" | cut -c1-5 | tr -d ' ' > /var/tmp/tel.pid &");

	fd = fopen("/var/tmp/tel.pid", "r");

	fgets(buf, sizeof(buf), fd);

	setenv("THEPID", buf, 1);
	system("kill -9 $THEPID &>/dev/null");

	unsetenv("THEPID");
	unsetenv("HOST");
	if (argc == 3) unsetenv("PORT");


	system("cat /var/tmp/tel | grep -vi \"trying\" | grep -vi \"connect\" | grep -vi \"login\" | grep -vi \"escape\"");
        putchar('\n');

	unlink("/var/tmp/tel.pid");
	unlink("/var/tmp/tel");
	fclose(fd);

	sleep(5);
	system("reset");
  } else {
	printf("Need to enter a host and optionally a port.\n");
	exit(1);
  }
  
}
